#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <piece.h>

unsigned char vbuff[128 * 88];
static unsigned char draw;

extern unsigned char A[];
extern unsigned char B[];

DRAW_OBJECT obj;
PIECE_BMP pbmp1;
PIECE_BMP pbmp2;

void pceAppInit( void )
{
	unsigned char* vram;
	PBMP_FILEHEADER pbhead;

	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(160);
	memset(vbuff, 0, 128 * 88);

	pceFontSetPos(0, 0);
//	pceFontPrintf("Hello, World");

	draw = 1;

	memcpy(&pbhead, A, sizeof(PBMP_FILEHEADER));
	pbmp1.header = pbhead;
	pbmp1.buf  = A + sizeof(PBMP_FILEHEADER);
	pbmp1.mask = A + sizeof(PBMP_FILEHEADER) + (pbmp1.header.h * pbmp1.header.w) / 4;

	memcpy(&pbhead, B, sizeof(PBMP_FILEHEADER));
	pbmp2.header = pbhead;
	pbmp2.buf  = B + sizeof(PBMP_FILEHEADER);
	pbmp2.mask = B + sizeof(PBMP_FILEHEADER) + (pbmp2.header.h * pbmp2.header.w) / 4;

	pceLCDSetObject(&obj, &pbmp2,  0, 0, 0, 0, 128, 88, DRW_NOMAL);
	pceLCDDrawObject(obj);
	pceLCDSetObject(&obj, &pbmp1, 40, 0, 0, 0,  48, 72, DRW_NOMAL);
	pceLCDDrawObject(obj);
	vram = pceLCDSetBuffer(INVALIDPTR);

	pceLCDDispStart();
}


void pceAppProc( int cnt )
{
	int ptn[] = { 0,1,2,0,3,4 };
	static int count = 0;
	int x = cnt * 4 & 127;
	draw = 1;

	pceLCDSetObject(&obj, &pbmp2, 0, 0, x, 0, 128 - x, 88, DRW_NOMAL);
	pceLCDDrawObject(obj);
	pceLCDSetObject(&obj, &pbmp2, 128 - x, 0, 0, 0, x, 88, DRW_NOMAL);
	pceLCDDrawObject(obj);
	pceLCDSetObject(&obj, &pbmp1, 40, 0, 0, 72 * ptn[count % 6], 48, 72, DRW_NOMAL);
	pceLCDDrawObject(obj);
	pceFontSetPos(0, 0);
	count++;

	if(draw) {
		pceLCDTrans();
		draw = 0;
	}
}


void pceAppExit( void )
{
}
